import xmlrpclib
import SimpleXMLRPCServer
import jabber
import sys
import sha
import string
import sys, re, os, string

Server = 'localhost'
Username = 'peer-b'
Password = 'peer-b'
Resource = 'rpc'



# Global procedures:
def Rot13(text):
    rot= ""
    for x in range(len(text)):
        byte = ord(text[x])
        cap = (byte & 32)
        byte = (byte & (~cap))
        if (byte >= ord('A')) and (byte <= ord('Z')):
            byte = ((byte - ord('A') + 13) % 26 + ord('A'))
        byte = (byte | cap)
        rot = rot + chr(byte)
    return rot



def iqCB(con, iq):
    print "iqCB called."
    
    myFromID = iq.getTo()
    
    type = iq.getType()
    query_ns = iq.getQuery()
    print "query_ns:", query_ns
    payload = iq.getQueryPayload()
    print "Payload-->\n", payload
    payload = xmlrpclib.loads(str(payload))
    print "Payload.loads()-->\n", payload

    if query_ns ==  jabber.NS_RPC:
      print "jabber.NS_RPC"
      resultIq = jabber.Iq(to=iq.getFrom(), type='result')
      resultIq.setID(iq.getID())
      resultIq.setFrom(iq.getTo())
      query_result = resultIq.setQuery(iq.getQuery()) # why have this?
      resultIq.setQuery(jabber.NS_RPC)
      evalString = payload[1]+"('"+payload[0][0]+"')"
      returnParams = xmlrpclib.dumps(tuple([eval(evalString)]))
      print "returnParams==>\n", returnParams
      resultIq.setQueryPayload(returnParams)
      con.send(resultIq)


def presenceCB(con, pres):
    "Got PresenceCB"
    pass
    
def messageCB(con, msg):
     "Got messageCB"
     pass

#--------- "MAIN" -----------------------------

#con = jabber.Client(host=Server, debug=0, port=8000, log='log')
con = jabber.Client(host=Server)
 
try:
    con.connect()
except IOError, e:
    print "Couldn't connect: %s" % e
    sys.exit(0)
else:
    print "Connected"
    
con.process(1)

if con.auth(Username, Password, Resource):
    print "Authorised"
else:
    print "problems with handshake: ", con.lastErr, con.lastErrCode
    sys.exit(1)

con.setMessageHandler(messageCB)
con.setPresenceHandler(presenceCB)
con.setIqHandler(iqCB)

#srvr = SimpleXMLRPCServer.SimpleXMLRPCServer(("localhost", 8080))
#srvr.register_instance(Echo)


#print 'Echo @ localhost:8000'
WAITSECONDS = 300
try:
    while(1):
        con.process(WAITSECONDS)

except KeyboardInterrupt:
    con.disconnect()
