import xmlrpclib
import jabber
import sys, re, os, string

Server = 'localhost'
Username = 'peer-b'
Password = 'peer-b'
Resource = 'rpc'

ServiceEndpoint = "http://localhost:9000"

# Global procedures:

def iqCB(con, iq):    
    query_ns = iq.getQuery()

    if query_ns ==  jabber.NS_RPC:
      payload = iq.getQueryPayload()
      #print "Payload-->\n", payload
      payload = xmlrpclib.loads(str(payload))
      #print "Payload.loads()-->\n", payload
      rotServer = xmlrpclib.ServerProxy(ServiceEndpoint)
      payload = payload[0][0]
      #print "payload==>",str(payload)
      rotText = rotServer.Rot13(payload)
      resultIq = jabber.Iq(to=iq.getFrom(), type='result')
      resultIq.setID(iq.getID())
      resultIq.setFrom(iq.getTo())
      query_result = resultIq.setQuery(iq.getQuery()) # why have this?
      resultIq.setQuery(jabber.NS_RPC)
      rotText = xmlrpclib.dumps(tuple([rotText]))
      resultIq.setQueryPayload(rotText)

      con.send(resultIq)


def presenceCB(con, pres):
    pass
    
def messageCB(con, msg):
     pass

#--------- "MAIN" -----------------------------

con = jabber.Client(host=Server)
 
try:
    con.connect()
except IOError, e:
    print "Couldn't connect: %s" % e
    sys.exit(0)
else:
    print "Connected"
    
con.process(1)

if con.auth(Username, Password, Resource):
    print "Authorised"
else:
    print "problems with handshake: ", con.lastErr, con.lastErrCode
    sys.exit(1)

con.setMessageHandler(messageCB)
con.setPresenceHandler(presenceCB)
con.setIqHandler(iqCB)

WAITSECONDS = 300
try:
    while(1):
        con.process(WAITSECONDS)

except KeyboardInterrupt:
    con.disconnect()
