import xmlrpclib
import SimpleXMLRPCServer
import jabber
import sys
import sha
import string
import sys, re, os, string

Server = 'localhost'
Username = 'server'
Password = 'server'
Resource = 'rpc'


def Echo(incomingString):
    """
    Sort the letters in the input and return them. Basically do some nonsense
    to illustrate XML-RPC
    """
    print "Echo called()"
    l = list(incomingString)
    l.sort()
    return "".join(l)



# Global procedures:
def iqCB(con, iq):
    print "iqCB called."
    
    myFromID = iq.getTo()
    
    type = iq.getType()
    query_ns = iq.getQuery()
    print "query_ns:", query_ns
    payload = iq.getQueryPayload()
    print "Payload-->\n", payload
    print "Payload.loads()-->\n", xmlrpclib.loads(str(payload))

    

    if query_ns ==  jabber.NS_RPC:
      print "jabber.NS_RPC"
      resultIq = jabber.Iq(to=iq.getFrom(), type='result')
      resultIq.setID(iq.getID())
      resultIq.setFrom(iq.getTo())
      query_result = resultIq.setQuery(iq.getQuery()) # why have this?
      resultIq.setQuery(jabber.NS_RPC)

      fake_payload = """<?xml version='1.0'?>
<param>
<value><string>    STaeghiiinrsssttt</string></value>
</param>
</params> """
      resultIq.setQueryPayload(fake_payload)
      con.send(resultIq)


def presenceCB(con, pres):
    "Got PresenceCB"
    pass
    
def messageCB(con, msg):
     "Got messageCB"
     pass

#--------- "MAIN" -----------------------------

#con = jabber.Client(host=Server, debug=0, port=8000, log='log')
con = jabber.Client(host=Server)
 
try:
    con.connect()
except IOError, e:
    print "Couldn't connect: %s" % e
    sys.exit(0)
else:
    print "Connected"
    
con.process(1)

if con.auth(Username, Password, Resource):
    print "connected"
else:
    print "problems with handshake: ", con.lastErr, con.lastErrCode
    sys.exit(1)

con.setMessageHandler(messageCB)
con.setPresenceHandler(presenceCB)
con.setIqHandler(iqCB)

srvr = SimpleXMLRPCServer.SimpleXMLRPCServer(("localhost", 8000))
srvr.register_instance(Echo)


print 'Echo @ localhost:8000'
WAITSECONDS = 300
try:
    while(1):
        con.process(WAITSECONDS)

except KeyboardInterrupt:
    con.disconnect()
